SystemOrganization addCategory: #'OmniVMNoOpt-Core-Reflection-Tests'!
SystemOrganization addCategory: #'OmniVMNoOpt-Core-Reflection'!
SystemOrganization addCategory: #'OmniVMNoOpt-Core-Misc'!
SystemOrganization addCategory: #'OmniVMNoOpt-Transporter'!

TestCase subclass: #ONOCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOCompilerTest methodsFor: 'helper' stamp: 'StefanMarr 7/19/2012 22:56'!
methodWithOmniMetaExit
	<omniUnenforced>
	^ self! !

!ONOCompilerTest methodsFor: 'helper' stamp: 'StefanMarr 3/10/2012 19:47'!
methodWithoutAnyPragma
	^ self! !

!ONOCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/10/2012 19:49'!
testOmniMetaExitMethodFlag
	"IMPORTANT: we assume the code has be already compiled with a suitable compiler"
	
	self assert: (self class >> #methodWithoutAnyPragma) flag not.
	
	self assert: (self class >> #methodWithOmniMetaExit) flag.! !

TestCase subclass: #ONODomainTest
	instanceVariableNames: ''
	classVariableNames: 'SomeClassVar'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONODomainTest methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 10:35'!
helperExecuteAllMessages: o
	self assert: #a equals: o a.
	self assert: #b equals: o b.
	self assert: nil equals: o magicNil.
	self assert: 1 equals: o magicOne.
	self assert: o equals: o magicSelf.
	self assert: 'ab' equals: o ab.
	
	o b: #bb.
	self assert: #bb equals: o b.
	
	o a: #aa.
	self assert: #aa equals: o a. 
	
	o makeOne.
	self assert: 1 equals: o b.! !

!ONODomainTest methodsFor: 'test helper' stamp: 'StefanMarr 11/12/2011 21:33'!
helperExecuteAllMessagesSimple: o
	o a.
	o b.
	o magicNil.
	o magicOne.
	o magicSelf.
	o ab.
	o b: #bb.
	o a: #aa.
	o makeOne.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 19:22'!
testAdopt
	| o d |
	o := Object new.
	d := OstDomain new.
	
	self assert: nil equals: (ONOMirror domainOf: o).
	
	d adoptObject: o.
	
	self assert: d equals: (ONOMirror domainOf: o).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/14/2012 17:53'!
testClass
	| d o c |
	d := ONOTestDomain new.
	o := ONOTestObject new.
	d adoptObject: o.
	
	c := [o class] omni: d.
	
	self assert: ONOTestObject equals: c.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/14/2012 18:00'!
testClone
	| d o clone |
	d := ONOTestDomain new.
	o := ONOTestObject new.
	d adoptObject: o.
	
	clone := [o copy] omni: d.
	
	self assert: d equals: (OstMirror domainOf: clone).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 21:56'!
testDomainForNewObjectsInitialization
	| domain |
	domain := ONOTestDomain new.
	self assert: domain equals: domain domainForNewObjects.
	
	self assert: domain equals: (domain instVarNamed: #domainForNewObjects).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 14:11'!
testLiteralReadWithDomain
	| d read |
	d := ONOTestDomain new.
	
	read := [ ONODomainTest ] omni: d.

	self assert: ONODomainTest equals: read.
	self assert: (Smalltalk associationAt: #ONODomainTest) equals: d readLiteral first.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 16:17'!
testLiteralWriteWithDomain
	| d read |
	d := ONOTestDomain new.
	
	SomeClassVar := nil.
	
	read := [ SomeClassVar := #foo ] omni: d.

	self assert: read equals: #foo.
	self assert: SomeClassVar equals: #foo.
	self assert: d writtenLiteral equals: (ONODomainTest bindingOf: #SomeClassVar).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 12:39'!
testReadWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[self helperExecuteAllMessages: o ] omni: d.

	self assert: 3 equals: d readCountA.
	self assert: 4 equals: d readCountB.
	
	self assert: 1 equals: d writeCountA.
	self assert: 2 equals: d writeCountB.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 17:45'!
testRequestExecWithDomain
	| o d expectedSelectors |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	expectedSelectors := ONOTestObject selectors reject: [:sel | sel = #initialize].
	
	[self helperExecuteAllMessages: o ] omni: d.

	"All selectors that are expected should already be in that set, and then there are a few more
	 which actually got recorded because of the implementation details of the methods executed"
	self assert: (d requestedSelectors union: expectedSelectors) equals: d requestedSelectors.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 12:40'!
testSimpleReadWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a ] omni: d.

	self assert: 1 equals: d readCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/21/2012 15:40'!
testSimpleSuperSendWithDomain
	| o d |
	o := ONOTestObjectSub new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a ] omni: d.
 
	self assert: #a equals: d lastSuperSelector.
	self assert: 1 equals: d readCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 14:39'!
testSimpleWriteWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a: #bbb ] omni: d.

	self assert: 1 equals: d writeCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/1/2012 17:26'!
testSpecialSendBytecode
	| o d r |
	o := ONOTestObjectSub new.
	o initForTestSpecialSendBytecode.
	d := OstDomain new.
	d adoptObject: o.
	
	r := [ o next ] omni: d.

	self assert: 1 equals: o a.
	self assert: #first equals: r.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/1/2012 21:54'!
testTimesRepeat
	| o d r |
	o := ONOTestObjectSub new.
	o initForTimesRepeat.
	d := OstDomain new.
	d adoptObject: o.
	
	r := [ o repeat: 4 on: o ] omni: d.

	self assert: 4 equals: o c.
	o collection do: [:execOnBase |
		self assert: execOnBase].
! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 17:45'!
testWithDomain
	| o d expectedSelectors |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	expectedSelectors := ONOTestObject selectors asOrderedCollection reject: [:sel | sel = #initialize].
	expectedSelectors add: #=.
	
	[self helperExecuteAllMessages: o ] omni: d.
	
	"All selectors that are expected should already be in that set, and then there are a few more
	 which actually got recorded because of the implementation details of the methods executed"
	self assert: (d requestedSelectors union: expectedSelectors) equals: d requestedSelectors.
	
	self assert: 3 equals: d readCountA.
	self assert: 4 equals: d readCountB.
	
	self assert: 1 equals: d writeCountA.
	self assert: 2 equals: d writeCountB.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 11/11/2011 00:35'!
testWithNilDomain
	| o |
	o := ONOTestObject new.
	self helperExecuteAllMessages: o.! !

TestCase subclass: #ONOMirrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOMirrorTest methodsFor: 'helpers' stamp: 'StefanMarr 7/19/2012 22:56'!
onMetaLevel
	<omniUnenforced>
	^ ONOMirror executesOnMetaLevel! !

!ONOMirrorTest methodsFor: 'helpers' stamp: 'StefanMarr 3/10/2012 19:51'!
onSomeLevelNoPragma
	^ ONOMirror executesOnMetaLevel! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/15/2012 15:14'!
testBaselevelPerform
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 15:33'!
testBaselevelPerformWithArguments
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma withArguments: #()) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 15:34'!
testBaselevelPerformWithArgumentsInSuperclass
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma withArguments: #() inSuperclass: self class) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 22:56'!
testBlockBaseLevel
	| d baseLevel |
	d := OstDomain new.
	
	baseLevel := [ ONOMirror executesOnBaseLevel ] omni: d.
	
	self assert: baseLevel.
	
	! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 22:58'!
testBlockBaseLevelValueWithArgs
	| baseLevel |
	
	ONOMirror switchToBaseLevel.
	
	baseLevel := [:i | ONOMirror executesOnBaseLevel ] value: 1.
	
	ONOMirror switchToMetaLevel.
	
	self assert: baseLevel.
	
	! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 21:46'!
testMetaExitPragma
	| onBaseLvl1 onBaseLvl2 onMetaLvl |
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: self onMetaLevel.
	
	self assert: self onSomeLevelNoPragma.
	
	ONOMirror switchToBaseLevel.
	
	"We post-pone the asserts to not run into trouble with SUnit and the tests."
	onBaseLvl1 := self onSomeLevelNoPragma not.
	onMetaLvl := self onMetaLevel.
	onBaseLvl2 := self onSomeLevelNoPragma not.
	
	ONOMirror switchToMetaLevel.
	
	self assert: onBaseLvl1.
	self assert: onMetaLvl.
	self assert: onBaseLvl2.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 11:27'!
testOmniBlockThisContext
	| d  execD |
	d := OstDomain new.
	
	execD := [ ONOMirror domainOf: thisContext ] omni: d.
	
	self assert: d equals: execD.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/10/2012 18:33'!
testPrimitiveGetSetDomain
	| o d |
	o := Object new.
	
	self assert: nil equals: (ONOMirror domainOf: o).
	 
	d := Object new.
	ONOMirror setDomainOf: o to: d.
	self assert: d equals: (ONOMirror domainOf: o).! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 21:49'!
testSwitchExecLevel
	| baseLevel |
	self assert: ONOMirror executesOnMetaLevel.
	
	ONOMirror switchToBaseLevel.
	
	baseLevel := ONOMirror executesOnBaseLevel.
	ONOMirror switchToMetaLevel.
	
	self assert: baseLevel.
	self assert: ONOMirror executesOnMetaLevel.! !

!ZeroDivide class methodsFor: '*OmniVMNoOpt-Core-Misc' stamp: 'StefanMarr 7/19/2012 22:53'!
dividend: argument
	<omniUnenforced>
	^self new dividend: argument; yourself! !

!Exception methodsFor: '*OmniVMNoOpt-Core-signaling' stamp: 'StefanMarr 7/19/2012 22:54'!
signal
	"Ask ContextHandlers in the sender chain to handle this signal.  The default is to execute and return my defaultAction."
	<omniUnenforced>

	signalContext := thisContext contextTag.
	signaler ifNil: [ signaler := self receiver ].
	^ signalContext nextHandlerContext handleSignal: self! !

!Exception methodsFor: '*OmniVMNoOpt-Core-signaling' stamp: 'StefanMarr 7/19/2012 22:54'!
signal: signalerText
	"Signal the occurrence of an exceptional condition with a specified textual description."
	<omniUnenforced>
	self messageText: signalerText.
	^ self signal! !

!BlockClosure methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/20/2012 16:13'!
omni
	"Convenience method for testing, not really useful in general"
	^ self omni: OstDomain new! !

!BlockClosure methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/19/2012 14:27'!
omni: aDomain
	"Move to language/baselevel and in the context of the given domain"
	^ aDomain evaluateInContextOnBaseLevel: self! !

!UndefinedObject methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/20/2012 16:25'!
evaluateInContextOnBaseLevel: aBlock
	^ OstDomain new evaluateInContextOnBaseLevel: aBlock! !

!UndefinedObject methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 7/19/2012 23:00'!
readLiteral: lit
	<omniUnenforced>
	^ lit value! !

Array variableSubclass: #OstArray
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OstArray class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/10/2012 13:41'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!CompiledMethod methodsFor: '*OmniVMNoOpt-Compiler' stamp: 'StefanMarr 3/19/2012 15:19'!
methodFlag: aBool
	"set the user-level flag bit"
	| old |
	old := self flag.
	aBool
		ifTrue: [ self objectAt: 1 put: (self header bitOr: (1 << 29)) ]
		ifFalse: [self objectAt: 1 put: (self header bitAnd: (1 << 29) bitInvert) ].
	
	^ old! !

!CompiledMethod methodsFor: '*OmniVMNoOpt-Compiler' stamp: 'StefanMarr 7/19/2012 22:49'!
properties: aMethodProperties
	"Set the method-properties of the receiver to aMethodProperties."
	self literalAt: self numLiterals - 1
		put: (aMethodProperties isEmpty
				ifTrue: [aMethodProperties selector]
				ifFalse: [aMethodProperties
							setMethod: self;
							yourself]).
	
	"After setting the properties we need to reconsider the flag"
	(self pragmaAt: #omniUnenforced) ifNotNilDo: [:p | self methodFlag: true]. "For OmniST support"! !

!SmalltalkImage methodsFor: '*OmniVMNoOpt-special objects' stamp: 'StefanMarr 3/19/2012 14:32'!
recreateSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 100.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: (self specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it."
	newArray at: 25 put: (self specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: (self specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray at: 31 put: (self specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray at: 32 put: (Float new: 2).
	newArray at: 33 put: (LargePositiveInteger new: 4).
	newArray at: 34 put: 0@0.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context prototypes (yeah, right)"
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 36 put: (self specialObjectsArray at: 36). "Is the prototype MethodContext (unused by the VM)"
	newArray at: 37 put: BlockClosure.
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 38 put: (self specialObjectsArray at: 38). "Is the prototype BlockContext (unused by the VM)"
	"array of objects referred to by external code"
	newArray at: 39 put: (self specialObjectsArray at: 39).	"preserve external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: nil. "Reserved for a LinkedList instance for overlapped calls in CogMT"
	"finalization Semaphore"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	"newArray at: 51 put: #attemptToAssign:withIndex:."
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallback:stack:registers:jmpbuf:.
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Weak reference finalization"
	newArray at: 56 put: (self at: #WeakFinalizationList ifAbsent: []).

		"Omni Changes"
	newArray at: 61 put: #readField:of:.
	newArray at: 62 put: #requestExecutionOf:on:.
	newArray at: 63 put: #write:toField:of:.
	
	newArray at: 70 put: OstDomain.
	newArray at: 71 put: ONOMirror OstDomainSelectorArray.

	"Now replace the interpreter's reference in one atomic operation"
	self specialObjectsArray become: newArray! !

!SharedQueue methodsFor: '*OmniVMNoOpt-Core' stamp: 'StefanMarr 3/22/2012 15:20'!
peekWaiting
	^monitor critical: [
		monitor waitWhile: [ items isEmpty ].
		items first ]! !

Object subclass: #ONOMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!ONOMirror class methodsFor: 'VM support' stamp: 'StefanMarr 3/13/2012 18:25'!
OstDomainSelectorArray
	^ OstDomain methodDict keys asSortedCollection asArray! !

!ONOMirror class methodsFor: 'VM support' stamp: 'StefanMarr 4/23/2012 15:10'!
OstDomainSelectorIndicesCppClass
	"This method generates the Cpp class we use to access the method symbols
		
		ONOMirror OstDomainSelectorIndicesCppClass.
	"
	| cpp selectors i reqExecBits |
	
	"Make sure that the system dictionary is up to date"
	Smalltalk recreateSpecialObjectsArray.
	
	reqExecBits := 0.
	cpp := 'class OstDomainSelector_Indices {
public:
'.
	selectors := self OstDomainSelectorArray.
	
	i := 0.
	selectors do: [:sel |
		cpp := cpp, '  static const oop_int_t ', ((self SymbolForCpp: sel) padded: #right to: 60 with: $ ), ' = ', i asString, ';
'.
		i := i + 1.
											
		"REM: we do it after i+1, because we need 1-based indices for bitAt:"
		(sel beginsWith: #requestExecution)
			ifTrue: [	reqExecBits := reqExecBits bitAt: i put: 1. ].
	].
	
	cpp := cpp, '


'.
	
	"A second pass to generate masks"			
	i := 1.
	selectors do: [:sel |
		cpp := cpp, '  static const oop_int_t ', (((self SymbolForCpp: sel), '_Mask') padded: #right to: 60 with: $ ), ' = 0x', (0 bitAt: i put: 1) printStringHex, ' << Tag_Size;
'.
		i := i + 1.
	].

				
	cpp := cpp, '

  /** Make it easier to identify whether any of them is customize, remember that it''s and int
     and we need to shift the Tag_Bit */
  static const oop_int_t RequestExecutionMask = 0x', (reqExecBits printStringHex),' << Tag_Size;
'.

	cpp := cpp, '
};

'.
	^ cpp! !

!ONOMirror class methodsFor: 'VM support' stamp: 'StefanMarr 3/13/2012 15:49'!
SymbolForCpp: aSymbol
	| capitalizeNext |
	capitalizeNext := true.
	^ aSymbol collect: [:c |
		c = $:
			ifTrue: [ capitalizeNext := true. $_ ]
			ifFalse: [
				capitalizeNext
					ifTrue: [ capitalizeNext := false. c asUppercase ]
					ifFalse: [c]
			]
	].! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 4/22/2012 23:45'!
checkConsistencyForAllDomains
	"self checkConsistencyForAllDomains"
	OstDomain withAllSubclassesDo: [:c |
		self checkConsistencyOfDomain: c.
	].! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 4/22/2012 23:11'!
checkConsistencyOfDomain: aDomainClass
	"Do a simple check whether the definition seems to be proper."
	
	| selectors definedSelectors |
	(aDomainClass inheritsFrom: OstDomain)
		ifFalse: [Error signal: 'Not strictly necessary, but a convenient constraint for the moment.'].
	
	selectors := self OstDomainSelectorArray.
	
	definedSelectors := aDomainClass methodDict keys.
	
	(definedSelectors contains: [:sel | sel beginsWith: #requestExecution])
		ifTrue: [
			| reqExecSels missing |
			reqExecSels := selectors select: [:sel | sel beginsWith: #requestExecution ].
			missing := OrderedCollection new.
			
			reqExecSels do: [:sel | 
				(definedSelectors includes: sel) 
					ifFalse: [missing add: sel]].
			
			missing size > 0 ifTrue: [
				Warning signal: aDomainClass printString,
				' does only redefine part of the #requestExec* methods. The following are missing: ',
				(missing fold: [:a :b | a, ' ', b]).
			]
		]! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 4/23/2012 15:43'!
domain: aDomainClass customizesSelector: aSel
	(aDomainClass includesSelector: aSel)
		ifTrue: [^ true.].
		
	aDomainClass superclass == OstDomain ifFalse: [
		^ self domain: aDomainClass superclass customizesSelector: aSel].
	
	^ false! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 18:31'!
domainOf: anObject
	"Returns the domain object on success"
	<primitive: 'primitiveGetDomain' module: 'OmniPlugin'>
	^ -1! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 4/23/2012 15:42'!
encodingFor: aDomainClass
	| selectors encoding |
	
	(aDomainClass includesBehavior: OstDomain)
		ifFalse: [Error signal: 'Not strictly necessary, but a convenient constraint for the moment.'].
	
	selectors := self OstDomainSelectorArray.
	
	encoding := 0.
	
	selectors withIndexDo: [:sel :i |
		(self domain: aDomainClass customizesSelector: sel)
			ifTrue: [
				encoding := encoding bitAt: i put: 1.]].
	
	^ encoding! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:54'!
evaluate: block onBaseLevel: domain
	<omniUnenforced>
	<primitive: 'primitiveEvaluateOnBaseLevel' module: 'OmniPlugin'>
	^ block value! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:55'!
executesOnBaseLevel
	<omniUnenforced>
	<primitive: 'primitiveExecutesOnBaseLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:55'!
executesOnMetaLevel
	<omniUnenforced>
	<primitive: 'primitiveExecutesOnMetaLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 18:28'!
setDomainOf: anObject to: aDomain
	"Returns self on success"
	<primitive: 'primitiveSetDomain' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:54'!
switchToBaseLevel
	<omniUnenforced>
	<primitive: 'primitiveSwitchToBaseLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:54'!
switchToMetaLevel
	<omniUnenforced>
	<primitive: 'primitiveSwitchToMetaLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 4/23/2012 15:43'!
updateDomainCustomizationsForAllDomains
	"self updateDomainCustomizationsForAllDomains"
	OstDomain withAllSubclassesDo: [:c |
		| encoding |
		encoding := self encodingFor: c.
		c class compile: ('domainCustomizations ^ ', encoding hex) classified: 'VM support'.
	].! !

ONOMirror subclass: #OstMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

Object subclass: #ONOTestObject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:45'!
a
	^ a! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:45'!
a: anObj
	a := anObj! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 21:22'!
ab
	^ a, b! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:46'!
b
	^ b! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:48'!
b: anObj
	b := anObj! !

!ONOTestObject methodsFor: 'initialize-release' stamp: 'StefanMarr 4/22/2012 17:46'!
initialize
	a := #a.
	b := #b.! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicNil
	^ nil! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicOne
	^ 1! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicSelf
	^ self! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
makeOne
	b := 1.! !

ONOTestObject subclass: #ONOTestObjectSub
	instanceVariableNames: 'c collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestObjectSub methodsFor: 'test helper' stamp: 'StefanMarr 3/21/2012 15:37'!
a
	^ super a! !

!ONOTestObjectSub methodsFor: 'test helper' stamp: 'StefanMarr 4/1/2012 14:24'!
c
	^ c! !

!ONOTestObjectSub methodsFor: 'test helper' stamp: 'StefanMarr 4/1/2012 21:53'!
collection
	^ collection! !

!ONOTestObjectSub methodsFor: 'testTimesRepeat' stamp: 'StefanMarr 4/1/2012 21:53'!
incC: n
	c := c + n.
	collection at: c put: ONOMirror executesOnBaseLevel.! !

!ONOTestObjectSub methodsFor: 'testSpecialSendBytecode' stamp: 'StefanMarr 4/1/2012 14:01'!
initForTestSpecialSendBytecode
	a := 0.
	b := 0.
	c := 0.
	collection := OrderedCollection new.
	collection add: #first.! !

!ONOTestObjectSub methodsFor: 'testTimesRepeat' stamp: 'StefanMarr 4/1/2012 21:52'!
initForTimesRepeat
	c := 0.
	collection := Array new: 4.! !

!ONOTestObjectSub methodsFor: 'testSpecialSendBytecode' stamp: 'StefanMarr 4/1/2012 17:26'!
next
	"For the test necessary of missbehavior of BGRepeatStream>>#next"

	^collection at: (a := a + 1)! !

!ONOTestObjectSub methodsFor: 'testTimesRepeat' stamp: 'StefanMarr 4/1/2012 20:23'!
repeat: n on: o
	n timesRepeat: [o incC: 1]! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OPromise commentStamp: 'StefanMarr 3/9/2012 21:09' prior: 0!
Provides a simple promise implementation.
A promise is a value that is going to be resolved in the future, typically by an asynchronous computation.
Reading an unresolved promise is a blocking operation.!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/19/2012 22:53'!
await
	<omniUnenforced>
	[value = NoValueDelivered] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		"signal waitTimeoutMSecs: 100. only available in Pharo"
		(Delay new setDelay:100 forSemaphore: signal) wait.
	].! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/19/2012 22:53'!
deliver: aValue
	<omniUnenforced>
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 7/19/2012 22:59'!
read
	<omniUnenforced>
	self await.
	^ value! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: aSymbol 
	"Send the unary selector, aSymbol, to the receiver.
	Fail if the number of arguments expected by the selector is not zero.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array new: 0)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ otherTarget baselevelPerform: selector! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:14'!
baselevelPerform: aSymbol with: anObject 
	"Send the selector, aSymbol, to the receiver with anObject as its argument.
	Fail if the number of arguments expected by the selector is not one.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array with: anObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not two.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array with: firstObject with: secondObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/17/2012 12:30'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: p4)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8. p9}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:19'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8. p9. p10}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:19'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 with: p11
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8. p9. p10. p11}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:34'!
baselevelPerform: selector withArguments: argArray 
	"Send the selector, aSymbol, to the receiver with arguments in argArray.
	Fail if the number of arguments expected by the selector 
	does not match the size of argArray.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 186>
	^ self baselevelPerform: selector withArguments: argArray inSuperclass: self class! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:35'!
baselevelPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 187>
	(selector isMemberOf: Symbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*OmniVMNoOpt' stamp: 'StefanMarr 7/19/2012 22:53'!
doesNotUnderstand: aMessage
	<omniUnenforced>
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"
	"fixed suggested by Eliot miranda to make sure 
	
	[Object new blah + 1]
		on: MessageNotUnderstood
		do: [:e | e resume: 1] does not loop indefinitively"
		
	| exception resumeValue |
	(exception := MessageNotUnderstood new)
		message: aMessage;
		receiver: self.
	resumeValue := exception signal.
	^exception reachedDefaultHandler
		ifTrue: [aMessage sentTo: self]
		ifFalse: [resumeValue]! !

Object subclass: #OmniNoOptTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Transporter'!

!OmniNoOptTransporter class methodsFor: 'transporter' stamp: 'StefanMarr 11/10/2011 16:38'!
transportersForFileOutMenu
	^ { Transporter forPackage: (PackageInfo named: 'OmniVMNoOpt') }! !

Object subclass: #OstDomain
	instanceVariableNames: 'domainForNewObjects domainCustomizations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!OstDomain commentStamp: 'StefanMarr 4/22/2012 21:58' prior: 0!
OstDomain is the root class for all Omni Domain definitions.

Instance Variables:
	domainForNewObjects	<OstDomain> - it is a cache for the #domainForNewObjects message,
											which is initialized on creation of the domain object.
											It is an optimization for the VM, to not need to execute the method
											which would have been a lot harder to implement correctly.
	
	domainCustomizations	<SmallInteger> - encoding which omni handlers have been customized in the domain.
											This allows avoiding unnecessary overhead in the VM.
											The encoding is defined corresponding to the index of the selectors in
											the ONOMirror >> #OstDomainSelectorArray.!

OstDomain subclass: #ONORWTestDomain
	instanceVariableNames: 'target cntReadA cntReadB cntWriteA cntWriteB lastSuperSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONORWTestDomain class methodsFor: 'VM support' stamp: 'StefanMarr 4/23/2012 15:43'!
domainCustomizations ^ 16r14002010! !

!ONORWTestDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 3/14/2012 11:09'!
initialize
	super initialize.
	
	cntReadA := 0.
	cntReadB := 0.
	cntWriteA := 0.
	cntWriteB := 0.! !

!ONORWTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 3/21/2012 15:39'!
lastSuperSelector
	^ lastSuperSelector! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
readCountA
	^ cntReadA! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
readCountB
	^ cntReadB! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		[Transcript cr; show: 'read field: ', idx asString.].
		
		idx = 1 ifTrue: [cntReadA := cntReadA + 1.].
		idx = 2 ifTrue: [cntReadB := cntReadB + 1.].
	].
	
	^ obj instVarAt: idx! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
requestExecutionOf: aSelector with: argArray lookup: cls on: anObject
	<omniUnenforced>
	lastSuperSelector := aSelector.
	^ anObject baselevelPerform: aSelector withArguments: argArray inSuperclass: cls.! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
target: targetObj
	target := targetObj! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		[Transcript cr; show: 'write to field: ', idx asString].
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ obj! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
writeCountA
	^ cntWriteA! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
writeCountB
	^ cntWriteB! !

OstDomain subclass: #ONOTestDomain
	instanceVariableNames: 'target requestedSelectors cntReadA cntReadB cntWriteA cntWriteB readLiteral writtenLiteral'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestDomain class methodsFor: 'VM support' stamp: 'StefanMarr 4/23/2012 15:43'!
domainCustomizations ^ 16r3200E010! !

!ONOTestDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 4/22/2012 14:07'!
initialize
	super initialize.
	
	requestedSelectors := Set new.

	cntReadA := 0.
	cntReadB := 0.
	cntWriteA := 0.
	cntWriteB := 0.

	readLiteral := OrderedCollection new.! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
readCountA
	^ cntReadA! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
readCountB
	^ cntReadB! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntReadA := cntReadA + 1.].
		idx = 2 ifTrue: [cntReadB := cntReadB + 1.].
	].
	
	^ obj instVarAt: idx! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 4/22/2012 12:15'!
readLiteral
	^ readLiteral! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readLiteral: literal
	<omniUnenforced>
	readLiteral add: literal.
	^ literal value! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecution: p1 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecutionOf: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecutionOf: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 23:12'!
requestedSelectors
	^ requestedSelectors! !

!ONOTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 22:38'!
target: targetObj
	target := targetObj! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ obj! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toLiteral: literal
	<omniUnenforced>
	"All globals are literals, and we treat all literals equal in the VM"
	
	writtenLiteral := literal.
	
	literal value: val.
	^ val! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
writeCountA
	^ cntWriteA! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
writeCountB
	^ cntWriteB! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 4/22/2012 12:16'!
writtenLiteral
	^ writtenLiteral! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 7/19/2012 22:53'!
currentDomain
	<omniUnenforced>
	^ ONOMirror domainOf: thisContext! !

!OstDomain class methodsFor: 'VM support' stamp: 'StefanMarr 4/23/2012 15:43'!
domainCustomizations ^ 16r3FFFFFFF! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 3/10/2012 18:32'!
omniDomainFrom: obj
	^ ONOMirror domainOf: obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/10/2012 18:33'!
adoptObject: obj
	ONOMirror setDomainOf: obj to: self.
	^ obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:06'!
domainForNewObjects
	"#basicNew need to determine which domain a new object is supposed
	 to belong to.
	 The standard domain is self, the domain of the currently executing
	 OProcess.
	
	 If this method is overriden, make sure that you do not allocate any objects here!!!!!!"
	^ self! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/13/2012 12:40'!
evaluateInContext: aBlock
	| oldDomain result |
	oldDomain := ONOMirror domainOf: thisContext.
	
	ONOMirror setDomainOf: thisContext to: self.
	
	result := aBlock value.
	
	ONOMirror setDomainOf: thisContext to: oldDomain.
	
	^ result! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 7/19/2012 22:54'!
evaluateInContextOnBaseLevel: aBlock
	<omniUnenforced>
	^ ONOMirror evaluate: aBlock onBaseLevel: self! !

!OstDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 4/23/2012 15:45'!
initialize
	super initialize.
	domainForNewObjects := self domainForNewObjects.
	domainCustomizations := self class domainCustomizations. "ONOMirror encodingFor: self class"! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/20/2012 16:18'!
newProcessFor: aBlock
	"Answer a Process running the code in aBlock in this domain.
	 The process is not scheduled."
	| ctx proc |
	<primitive: 19> "Simulation guard"
	ctx := [aBlock value.
			Processor terminateActive] asContext.
	proc := Process
		forContext: ctx
		priority: Processor activePriority.

	ONOMirror setDomainOf: ctx to: self.
	ONOMirror setDomainOf: proc to: self.
	^ proc.! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primAt: idx on: anObj
	<omniUnenforced>
	^ anObj at: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj at: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primBasicAt: idx on: anObj
	<omniUnenforced>
	^ anObj basicAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj basicAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primInstVarAt: idx on: anObj
	<omniUnenforced>
	^ anObj instVarAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj instVarAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primShallowCopy: anObj
	<omniUnenforced>
	^ anObj shallowCopy! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readLiteral: literal
	<omniUnenforced>
	^ literal value! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8  of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9  of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
requestExecutionOf: aSelector with: argArray lookup: cls on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector withArguments: argArray inSuperclass: cls.! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/31/2012 18:28'!
spawnHere: aBlock
	"Spawn the given block as a process in this domain"	
	^ (self newProcessFor: aBlock) resume! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx put: val.! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toLiteral: literal
	<omniUnenforced>
	"All globals are literals, and we treat all literals equal in the VM"
	literal value: val.
	^ val! !

Object subclass: #OstObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OstObject commentStamp: 'StefanMarr 3/9/2012 21:08' prior: 0!
This is a compatibility class with the same name as what I got in the bytecode transformation-based implementation.!

!OstObject class methodsFor: 'OmniST-compatibility' stamp: 'StefanMarr 3/22/2012 14:21'!
omnifyClass: aClass
	"Does not need to do anything for OmniVMNoOpt, the VM provides the support directly."
	^ aClass! !

!String methodsFor: '*OmniVMNoOpt-Tests-Compatibility-OmniST' stamp: 'StefanMarr 3/20/2012 20:38'!
asNormalSelector
	^ self asSymbol! !
OPromise initialize!
